function Create(self)
	self.DoubleClickTimer = Timer();
	self.Clicked = true
	self.GliderEnabled = false
	self.GliderFrame = 0
end

function Update(self)
  local ctrl = self:GetController()
  if ctrl:IsState(Controller.BODY_CROUCH) then
    if self.Clicked then
      if self.DoubleClickTimer:IsPastSimMS(250) then
        self.DoubleClickTimer:Reset();
      else
        self.GliderEnabled = not self.GliderEnabled
      end
    end
    self.Clicked = false
  else
    self.Clicked = true
  end
  --Aerodynamic stuff
  
  if self.GliderEnabled then
    if self.GliderFrame < 10 then
      self.GliderFrame = self.GliderFrame + 1
      if self.HFlipped then
        self.AngularVel = self.AngularVel + 25/self.Mass
      else
        self.AngularVel = self.AngularVel - 25/self.Mass
      end
      self.AngularVel = self.AngularVel * 0.99897466013276793640773900351889^self.Mass
      self:AddAbsForce( self:RotateOffset(Vector(0 , -5000)),self.Pos );
    else
      self.GliderFrame = 10
    end
    if self.MovementState ~= 8 then
      self.MovementState = 8
    else
      self.MovementState = 0
    end
    self.JumpState = 3
    local direction = self.Vel.AbsRadAngle
    
    local AirRessistanceForce = 0.003 * self.AngularVel^2 * self.GliderFrame/self.Mass
    if self.AngularVel > 0 then
      if self.AngularVel - AirRessistanceForce > 0 then
        self.AngularVel = self.AngularVel - AirRessistanceForce
      else
        self.AngularVel = 0
      end
    else
      if self.AngularVel + AirRessistanceForce < 0 then
        self.AngularVel = self.AngularVel + AirRessistanceForce
      else
        self.AngularVel = 0
      end
    end
    local RotAngleVector = Vector(math.cos(self.RotAngle * -1 + math.pi*0.5) , math.sin(self.RotAngle * -1 + math.pi*0.5))
    local AirShadow = (RotAngleVector * (self.Vel.Normalized.X*RotAngleVector.X + self.Vel.Normalized.Y*RotAngleVector.Y)).Magnitude
    local RotAngleVectorPer = RotAngleVector.Perpendicular
    local DirectionalSpeed = (RotAngleVectorPer * (self.Vel.X*RotAngleVectorPer.X + self.Vel.Y*RotAngleVectorPer.Y)).Magnitude
    local negatore = 1
    if (self.Vel.Normalized.X*RotAngleVector.Y - self.Vel.Normalized.Y*RotAngleVector.X) < 0 then
      negatore = -1;
    end

    local DirectionalSpeedX = (RotAngleVector * (self.Vel.X*RotAngleVector.X + self.Vel.Y*RotAngleVector.Y)).Magnitude
  
    local modifier = 0
    if ctrl:IsState(Controller.MOVE_RIGHT) then
      modifier = 90/(100+math.abs(DirectionalSpeedX)^0.5)
    end
    if ctrl:IsState(Controller.MOVE_LEFT)then
      modifier = modifier - 90/(100+math.abs(DirectionalSpeedX)^0.5)
    end
    if ctrl:IsState(Controller.BODY_CROUCH) then
      modifier = modifier * 1.5*(100+math.abs(DirectionalSpeedX)^0.5)/100
    end
    local rotationstuff = self.AngularVel - math.sin((self.RotAngle + self.AngularVel*0.2 + math.pi*0.5 + modifier - direction)*2)*0.03*self.Vel.Magnitude^2 * self.GliderFrame/self.Mass
    if (self.AngularVel > 0 and rotationstuff < 0) or (self.AngularVel < 0 and rotationstuff > 0) then
      self.AngularVel = 0
    else
      self.AngularVel = rotationstuff
    end
        
    local AirRessistanceForce = AirShadow * -10 * DirectionalSpeed^2 * self.GliderFrame
    if self.Vel.Magnitude - AirRessistanceForce > 0 then
--      self.Vel = self.Vel - RotAngleVectorPer*AirRessistanceForce * negatore
      self:AddAbsForce( RotAngleVectorPer*AirRessistanceForce * negatore,self.Pos );
    else
      self.Vel = self.Vel - DirectionalSpeed
    end
  else
    if self.GliderFrame > 0 then
      self.GliderFrame = self.GliderFrame - 1
      if self.HFlipped then
        self.AngularVel = self.AngularVel - 25/self.Mass
      else
        self.AngularVel = self.AngularVel + 25/self.Mass
      end
      self.AngularVel = self.AngularVel * 1.05^(50/self.Mass)
      self:AddAbsForce( self:RotateOffset(Vector(0 , 5000)),self.Pos );
    else
      self.GliderFrame = 0
    end
  end
  self.Frame = math.floor(self.GliderFrame/2)
end
